package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.ClienteCorporativoDAO;
import com.rjconsultores.ventaboletos.entidad.ClienteCorporativo;
import com.rjconsultores.ventaboletos.service.ClienteCorporativoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("clienteCorpService")
public class ClienteCorporativoServiceImpl implements ClienteCorporativoService {

	@Autowired
	private ClienteCorporativoDAO clienteCorpDAO;

	public List<ClienteCorporativo> obtenerTodos() {
		return clienteCorpDAO.obtenerTodos();
	}

	public ClienteCorporativo obtenerID(Long id) {
		return clienteCorpDAO.obtenerID(id);
	}

	@Transactional
	public ClienteCorporativo suscribirActualizar(ClienteCorporativo entidad)  {		
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecModif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		if (entidad.getClienteCorporativoId() == null){
			return clienteCorpDAO.suscribir(entidad);
		}else{
			return clienteCorpDAO.actualizacion(entidad);
		}
	}

	@Transactional
	public void borrar(ClienteCorporativo entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecModif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		clienteCorpDAO.actualizacion(entidad);
	}

	@Override
	public ClienteCorporativo existe(Integer classe, Integer alias, Integer orgaoConcedente, Integer clienteCorpId) {
		return clienteCorpDAO.existe(classe, alias, orgaoConcedente, clienteCorpId);
	}

	@Override
	public List<ClienteCorporativo> buscar(Integer classe, Integer alias, Integer orgaoConcedente) {
		return clienteCorpDAO.buscar(classe, alias, orgaoConcedente);
	}

	@Override
	public List<ClienteCorporativo> buscaLike(String strClienteCorporativo) {
		return clienteCorpDAO.buscaLike( strClienteCorporativo);
	}
}
